aboutsummaryrefslogtreecommitdiffstats
path: root/bootstrap-verify-perf.sh
diff options
context:
space:
mode:
authorpmikus <pmikus@cisco.com>2016-03-29 12:56:12 +0200
committerGerrit Code Review <gerrit@fd.io>2016-04-01 13:31:31 +0000
commit4ae37074a3e74bd6fdcd606d1553b99131372c84 (patch)
tree26608a7abefb693c01fdc5af78705dc226852c75 /bootstrap-verify-perf.sh
parent476ea70ea42ccd6f0486fa799058d47647bc0942 (diff)
Bootstrap to test perf of proposed patch vpp-csit-hw-perf
- Based on #570 Lab reservation tool - Get the latest build of VPP - Make reservation on testbed by using existing topology files - Copy and install VPP image on all DUTs - Run performance tests Change-Id: I8034fd9c284cbe9a68e0c9116d0826965464b5f9 Signed-off-by: pmikus <pmikus@cisco.com>
Diffstat (limited to 'bootstrap-verify-perf.sh')
-rwxr-xr-xbootstrap-verify-perf.sh82
1 files changed, 82 insertions, 0 deletions
diff --git a/bootstrap-verify-perf.sh b/bootstrap-verify-perf.sh
new file mode 100755
index 0000000000..746d1a0a58
--- /dev/null
+++ b/bootstrap-verify-perf.sh
@@ -0,0 +1,82 @@
+#!/bin/bash
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -x
+
+# Space separated list of available testbeds, described by topology files
+TOPOLOGIES="topologies/available/lf_testbed2-710-520.yaml"
+
+# Reservation dir
+RESERVATION_DIR="/tmp/reservation_dir"
+
+# Jenkins VPP deb paths (convert to full path)
+VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
+
+CUR_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
+WORKING_TOPOLOGY=""
+export PYTHONPATH=${CUR_DIR}
+
+sudo apt-get -y update
+sudo apt-get -y install libpython2.7-dev python-virtualenv
+
+virtualenv env
+. env/bin/activate
+
+echo pip install
+pip install -r requirements.txt
+
+# We iterate over available topologies and wait until we reserve topology
+while :; do
+ for TOPOLOGY in ${TOPOLOGIES};
+ do
+ python ${CUR_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
+ if [ $? -eq 0 ]; then
+ WORKING_TOPOLOGY=${TOPOLOGY}
+ echo "Reserved: ${WORKING_TOPOLOGY}"
+ break
+ fi
+ done
+
+ if [ ! -z "${WORKING_TOPOLOGY}" ]; then
+ # Exit the infinite while loop if we made a reservation
+ break
+ fi
+
+ # Wait 10 - 30 sec. before next try
+ SLEEP_TIME=$[ ( $RANDOM % 20 ) + 10 ]s
+ echo "Sleeping ${SLEEP_TIME}"
+ sleep ${SLEEP_TIME}
+done
+
+python ${CUR_DIR}/resources/tools/topo_installation.py -t ${WORKING_TOPOLOGY} \
+ -d ${RESERVATION_DIR} \
+ -p ${VPP_DEBS}
+if [ $? -eq 0 ]; then
+ echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
+else
+ echo "Failed to copy vpp deb files to DUTs"
+ exit $?
+fi
+
+function cancel_reservation {
+ python ${CUR_DIR}/resources/tools/topo_reservation.py -c -t $1
+}
+
+# On script exit we cancel the reservation and delete all vpp packages
+trap "cancel_reservation ${WORKING_TOPOLOGY}" EXIT
+
+# run performance test suite
+pybot -L TRACE \
+ -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+ -s performance tests/